const path = require('path')
const { app, BrowserWindow, Menu, Tray, ipcMain, ipcRenderer,dialog } = require('electron')
const os = require('os')
const fs = require('fs');

const ThermalPrinter = require("node-thermal-printer").printer;
const PrinterTypes = require("node-thermal-printer").types;

const fetch = require('node-fetch');
const https = require('https');

const httpsAgent = new https.Agent({
      rejectUnauthorized: false,
    });

const pri = require('printer');


/*const updater = require("electron-updater");
const autoUpdater = updater.autoUpdater;

autoUpdater.requestHeaders = { "PRIVATE-TOKEN": "44698a828c641e0666b3f584216e7a3c1f80a2bd"};
autoUpdater.autoDownload = true;

autoUpdater.setFeedURL({
    provider: "github",
    repo:'capturador',
    owner:'byfood',
    private:true,
    token:'44698a828c641e0666b3f584216e7a3c1f80a2bd'
});

autoUpdater.on('checking-for-update', function () {
    sendStatusToWindow('Verificando atualizações...');
});

autoUpdater.on('update-available', function (info) {
    sendStatusToWindow('Atualização disponível.');
});

autoUpdater.on('update-not-available', function (info) {
    sendStatusToWindow('Nenhuma atualização disponível.');
});

autoUpdater.on('error', function (err) {
    sendStatusToWindow('Falha ao atualizar.');
});

autoUpdater.on('download-progress', function (progressObj) {
    let log_message = "Velocidade de Download: " + progressObj.bytesPerSecond;
    log_message = log_message + ' - Baixado ' + parseInt(progressObj.percent) + '%';
    log_message = log_message + ' (' + progressObj.transferred + "/" + progressObj.total + ')';
    sendStatusToWindow(log_message);
});

autoUpdater.on('update-downloaded', function (info) {
    sendStatusToWindow('Atualização baixada; instalando em 1 segundos.');
});

autoUpdater.on('update-downloaded', function (info) {
    setTimeout(function () {
        autoUpdater.quitAndInstall();
    }, 1000);
});

autoUpdater.checkForUpdates();

function sendStatusToWindow(message) {
    console.log(message);
}*/





//console.log('isConnected',isConnected);




//printer.cut() ;



//const notifier = require('node-notifier');

var tray;
let window = null;



function createWindow () {

  let icone = 'icon.ico';

   if(process.platform === 'darwin'){
    icone = 'icon2.png';
   }

   tray = new Tray(path.join(__dirname, icone))
  const contextMenu = Menu.buildFromTemplate([
    { label: 'Abrir',  click: () => window.show() },
    { label: 'Sair',  role:'quit' },

  ]);


  tray.on('double-click', (event, bounds) => {
    window.show();
  });

  tray.on('left-click', (event, bounds) => {
    window.show();
  });

  tray.on('click', (event, bounds) => {
    window.show();
  });
  


  //tray.setToolTip('This is my application.')
  tray.setContextMenu(contextMenu)


let _windowTitle = 'Capturador de Pedidos';

let urlDefault = 'https://byfood.com.br/admin/pdv/login';
let pathConfig = './config.json';

  if (fs.existsSync(pathConfig)) {
    
    let config = JSON.parse(fs.readFileSync(pathConfig));


    urlDefault = "https://"+config.dominio + "/admin/pdv/login";
    _windowTitle = config.nome;


  }else{
    console.log('Arquivo config não existe.');
  }

  console.log('Iniciando na URL: ' + urlDefault );


  // Cria uma janela de navegação.
   window = new BrowserWindow({
    title:_windowTitle,
    minWidth: 1080,
    minHeight: 600,
    width:1200,
    height:600,
    autoHideMenuBar: true,
    resizable: true,
    show: true,
    scrollBounce: true,
    webPreferences: {
      webSecurity: false,
      preload: path.join(__dirname, 'preload.js'),
    }
})

 // window.setIcon(__dirname + '/icon.png');
 
//console.log(window.webContents.getPrinters());  


 window.webContents.loadURL(urlDefault);
 var userAgent = 'ByFood';
 window.webContents.setUserAgent( window.webContents.getUserAgent().replace('byfoodpdv',userAgent) );



 window.webContents.once('dom-ready', () => {

     window.webContents.send('impressoras',pri.getPrinters());


     setInterval(function(){
        window.webContents.executeJavaScript("if(location.href.search('/pdv') === -1){ location.href='"+urlDefault+"' }")
    },1000)


});




  window.webContents.on('new-window', function(event, url){
  event.preventDefault();
  require('electron').shell.openExternal(url);
});

  var forceQuit = false;
  app.on('before-quit', function() {
    forceQuit = true;
  });

  var isClose = false;
   window.on('close', function(event) {
    if (!forceQuit) {
      event.preventDefault();

      isClose = true;



      window.hide();
    }
  });

   

   app.on('activate', function(){
    isClose = false;
    if(process.platform === 'darwin'){
      //app.dock.setBadge('');
      
      app.setBadgeCount(0);
    }

    if(process.platform === 'win32'){
      tray.setImage(path.join(__dirname, 'icon.ico'));
    }


      
      window.show();
   });


   app.on('browser-window-focus', function(){
    isClose = false;
    if(process.platform === 'darwin'){
      //app.dock.setBadge('');
      
      app.setBadgeCount(0);
    }

    if(process.platform === 'win32'){
      tray.setImage(path.join(__dirname, 'icon.ico'));
    }


      
      window.show();
   });

   app.on('minimize', function(){
    isClose = true;

      
   });

   app.on('blur', function(){
    isClose = true;

      
   });

   app.on('browser-window-blur', function(){
    isClose = true;

      
   });

   
 

     ipcMain.on('focus', (event, msg, options = {}) => {


      window.show();


     });

     

     ipcMain.on('refreshPrinters',(event, success, options = {}) => {

        window.webContents.send('impressoras',pri.getPrinters());

     });


     function viaBalcao(item, printer){
        var pedido = item;
        printer.alignCenter();
        printer.println(item.owner);
        if(!item.retirar_no_local && !pedido.is_mesa && item.qrcode != ''){
          printer.printQR(item.qrcode,{cellSize:3});
        }
        //printer.setTextNormal();
        printer.println();
        printer.alignLeft();
        printer.println('Loja: '+item.loja);
        printer.println('Pedido: '+item.pedido_prefix+item.pedido);
        if(pedido.is_mesa){
          printer.println('Data: '+item.data);
          printer.println('Mesa: '+item.mesa_id);
        }else{
          printer.println('Data: '+pedido.data);
        }

        if(item.previsao_entrega != '' && item.agendamento_data == ''){
          printer.println('Previsão de entrega: '+item.previsao_entrega);
        }
        if(item.agendamento_data != ''){
            printer.println('Agendamento: '+item.agendamento_data);
          }

        if(!pedido.is_mesa){
          printer.bold(true);
          printer.newLine();
          printer.println(item.pedido_loja);
          printer.newLine();


          if(item.nome != ''){
            printer.println('Dados do Cliente');
          }
          printer.bold(false);
          if(item.nome != ''){
            printer.println('Nome: '+item.nome);
          }
          if(item.celular != ''){
            printer.println('Celular: '+item.celular);
          }


          if(item.retirar_no_local){
            if(item.comer_no_local){
              printer.println('Comer no Local');
            }else{
              printer.println('Retirar no Local');
            }
          }else{
            if(item.logradouro != '')
            printer.println('Endereço: '+item.logradouro+', '+item.logradouro_numero);

            if(item.bairro != '')
            printer.println('Bairro: '+item.bairro);

            if(item.complemento != '' && item.complemento != 'Não informado' )
            printer.println('Compl: '+item.complemento);

            if(item.ponto_referencia){
              printer.println('Ponto Referência: '+item.ponto_referencia);
            }
            if(item.cidade != '' && (item.cidade+'').length > 3)
              printer.println('Cidade: '+item.cidade);
            }
        }

        printer.bold(true);
        printer.println('Itens do pedido');
        printer.bold(false);
        printer.leftRight('Qtd  Item','Preço');
        for(var vItem in item.itens){
          var spacingFirst = '    ';
          var strRs = 'R$';
          if(item.itens[vItem].valor == ""){
            strRs = '';
          }

           var qtd = item.itens[vItem].quantidade + ' ';
            if(!item.itens[vItem].exibir_quantidade){
              qtd = item.itens[vItem].quantidade == 1 ? '--' : (item.itens[vItem].quantidade+' ');
            }

          printer.leftRight(qtd+'   '+item.itens[vItem].titulo,strRs+item.itens[vItem].valor);
          if(item.itens[vItem].ean){
            printer.leftRight('     '+item.itens[vItem].ean,'');
          }
          let totalItens = 0;
          for(var vDesc in item.itens[vItem].descricao){
            totalItens += parseFloat((item.itens[vItem].descricao[vDesc].valor+'').replace('R$ ','').replace('R$','').replace('.','').replace(',','.'));
            printer.leftRight('     '+item.itens[vItem].descricao[vDesc].titulo,item.itens[vItem].descricao[vDesc].valor);
          }
          if(item.mostrar_subtotal_itens){
            printer.leftRight('',"------");
            printer.bold(true);
            printer.leftRight('',"R$"+item.itens[vItem].total)
            printer.bold(false);
          }
          // if(item.itens[vItem].obs !== ""){
          //   printer.println('OBS: '+item.itens[vItem].obs);
          // }
          if(vItem < (item.itens.length - 1) && item.impressao_espacamento_itens) printer.newLine();
        }
        if(!pedido.is_mesa || pedido.is_via_mesa_cliente == true){
          printer.drawLine();
          printer.leftRight('SubTotal','R$'+item.valor);
           if(item.is_mesa && pedido.is_via_mesa_cliente){
            printer.leftRight('Taxa de Serviço','R$'+item.mesa_taxa_servico);  
          }else{
            printer.leftRight('Taxa de Entrega','R$'+item.frete);
          }
          

          printer.leftRight('Desconto','R$'+item.desconto);

          if(item.has_troco){
            printer.bold(true);
            printer.leftRight('Troco','R$'+item.troco);
            printer.bold(false);
          }



          printer.bold(true);
          printer.leftRight('Cobrar do Cliente','R$'+item.total);
          printer.drawLine();
          printer.bold(false);
          if(!item.is_mesa){
            printer.println('Formas de pagamento')
            printer.bold(true);
            printer.println(item.forma_pagamento);
            printer.bold(false);
          }

          if(item.has_troco){ //242216
            printer.println('Valor a receber em dinheiro: R$ '+item.receber_dinheiro);
          }


          if(item.rodape != ''){
            var a = item.rodape.split('\n');
            for(var b in a){
                printer.println(a[b]);
            }
          }

        }
     }

     function marcarItemMesaImpresso( itemIDS ){



      fetch( "https://exemplo.byfood.com.br/admin/pdv/marcarComoImpresso/"+itemIDS+".json",  { method: "Get",agent: httpsAgent })
          .then(res => res.json())
          .then((json) => {
              console.log(json);

            });
     }

     ipcMain.on('imprimir',(event, pedidoID, options = {}) => {


      var isMesaFull = false;
      var impString = '';

      if(options.mesaFull !== undefined && options.mesaFull){
          isMesaFull = true;
          impString = '?is_via_mesa_cliente=1';
      }

        let url = "https://exemplo.byfood.com.br/admin/pedidos/printer/"+pedidoID+".json" + impString;
      let settings = { method: "Get",agent: httpsAgent };

      fetch(url, settings)
          .then(res => res.json())
          .then((json) => {
              let item = json.pedido;



      if(item.imprimir == false){
        dialog.showMessageBox(null,{title:'Mensagem',message: 'Todos itens foram impressos.'});
        return false;
      }

     if((item.impressora_principal+"").search('printer:auto') !== -1){



        let listPrinters = pri.getPrinters();


        if(listPrinters.length > 0){
          item.impressora_principal = listPrinters[0].name;
        }

        for( var b in listPrinters ){
          if(listPrinters[b].isDefault){
              item.impressora_principal = listPrinters[b].name;
          }
        }
      }

      let printer = new ThermalPrinter({                               
        interface: item.impressora_principal,                  
        driver: pri,
        width: item.impressao_width
 
      });

      if(item.impressao_fonte_grande){
        
        printer.setTextSize(0,1);
        //printer.setTextSize( parseInt(item.text_size) * 0.1,parseInt(item.text_size) * 0.1);
      }else{
        printer.setTextNormal();
      }

      //alert('teste');


      printer.isPrinterConnected(function(isOk){

        if(!isOk){
          dialog.showMessageBox(null,{title:'Mensagem',message: 'Impressora não conectada.'});
        }
      });

              console.log('j',json);


        viaBalcao(item,printer);

        if(item.recibo_2via && !item.is_mesa){
          printer.cut();
          viaBalcao(item,printer);  
        }

        if(item.viaCozinha && !item.is_mesa){

          if(item.impressao_fonte_grande){
            printer.setTextSize( 0,1);
          }else{
            printer.setTextNormal();
          }

          printer.cut();
          printer.drawLine();
          printer.alignCenter();
          printer.println(item.owner);
          printer.println('VIA DA COZINHA');
          if(item.retirar_no_local){
            printer.bold(true);
            if(item.comer_no_local){
              printer.println('Comer no Local');
            }else{
              printer.println('Retirar no Local');
            }
            printer.bold(false);
          }
           printer.alignLeft();
          printer.println('Loja: '+item.loja);
          printer.println('Pedido: #'+item.pedido);
          printer.println('Data: '+item.data);
          if(item.previsao_entrega != '' && item.agendamento_data == ''){
            printer.println('Previsão de entrega: '+item.previsao_entrega);
          }
          if(item.agendamento_data != ''){
            printer.println('Agendamento: '+item.agendamento_data);
          }
          if(item.nome != '')
          printer.println('Nome: '+item.nome);

          if(item.celular != '')
          printer.println('Celular: '+item.celular);



          printer.println('Itens do pedido');
          printer.leftRight('Qtd  Item','');

          for(var vItem in item.itens){
            var spacingFirst = '    ';

            var qtd = item.itens[vItem].quantidade + ' ';
            if(!item.itens[vItem].exibir_quantidade){
              qtd = item.itens[vItem].quantidade == 1 ? '--' : (item.itens[vItem].quantidade+' ');
            }

            printer.leftRight(qtd+'   '+item.itens[vItem].titulo,'');
            if(item.itens[vItem].ean){
              printer.leftRight('     '+item.itens[vItem].ean,'');  
            }
            totalItens = 0;
            for(var vDesc in item.itens[vItem].descricao){
              totalItens += parseFloat((item.itens[vItem].descricao[vDesc].valor+'').replace('R$ ','').replace('R$','').replace('.','').replace(',','.'));
              printer.leftRight('     '+item.itens[vItem].descricao[vDesc].titulo,'');
            }
            if(item.mostrar_subtotal_itens){
              printer.leftRight('',"------");
              printer.bold(true);
              printer.leftRight('',"R$"+item.itens[vItem].total);
              printer.bold(false);
            }
            // if(item.itens[vItem].obs !== ""){
            //   printer.println('OBS: '+item.itens[vItem].obs);
            // }

            if(vItem < (item.itens.length - 1) && item.impressao_espacamento_itens) printer.newLine();

          }
        }
        

        //console.log(printer.getText());
        printer.cut();
       try {
            printer.execute();

            if(item.is_mesa && item.itens_ids !== ""){
              marcarItemMesaImpresso( item.itens_ids );
            }

           


        }catch(err){
           dialog.showMessageBox(null,{title:'Mensagem',message: 'Não foi possível imprimir.\n'+err});
        }

        let pedidoDep = json.pedido_departamentos;
        var dep = json.departamentos;
        for(var u in pedidoDep){


        

          let printer = new ThermalPrinter({                               
            interface: dep[ u ].impressora,    
            width: dep[ u ].impressao_width,
            driver:pri               
 
          });

          printer.isPrinterConnected(function(isOk){
          if(!isOk){
            dialog.showMessageBox(null,{title:'Mensagem',message: 'Impressora não conectada. ' + dep[ u ].impressora});
          }
        });

          if(dep[ u ].impressao_fonte_grande){
            printer.setTextSize(0,1);
          }else{
            printer.setTextNormal();
          }

          printer.alignCenter();
          printer.println(item.owner);
          printer.println('VIA '+dep[u].titulo);
          if(item.retirar_no_local && !item.is_mesa){
            printer.bold(true);
            if(item.comer_no_local){
              printer.println('Comer no Local');
            }else{
              printer.println('Retirar no Local');
            }
            printer.bold(false);
          }
          printer.alignLeft();
          printer.println('Loja: '+item.loja);
          printer.println('Pedido: #'+item.pedido);
          printer.println('Data: '+item.data);
          if(item.previsao_entrega != '' && item.agendamento_data == ''){
            printer.println('Previsão de entrega: '+item.previsao_entrega);
          }
          if(item.agendamento_data != ''){
            printer.println('Agendamento: '+item.agendamento_data);
          }
          if(item.is_mesa){
            printer.println('Mesa: '+item.mesa_id);  
          }else{
            if(item.nome != '')
            printer.println('Nome: '+item.nome);

            if(item.celular != '')
            printer.println('Celular: '+item.celular);

            printer.bold(true);
            //printer.setTextSize(0,1);
            if(item.bairro != '')
            printer.println('Bairro: '+item.bairro);

            printer.bold(false);
          }


          printer.println('Itens do pedido');
          printer.leftRight('Qtd  Item','');

          
          var countDep = 0;
          for(var vItem in pedidoDep[ u ]){
           // printer.setTextSize(0,1);
            printer.bold(true);
            countDep++;
            var spacingFirst = '    ';

            var qtd = pedidoDep[u][vItem].quantidade + ' ';
            if(!pedidoDep[u][vItem].exibir_quantidade){
              qtd = pedidoDep[u][vItem].quantidade == 1 ? '--' : (pedidoDep[u][vItem].quantidade+' ') ;
            }

            printer.leftRight(qtd+'   '+pedidoDep[u][vItem].titulo,'');
            totalItens = 0;
            for(var vDesc in pedidoDep[u][vItem].descricao){
              printer.leftRight('     '+pedidoDep[u][vItem].descricao[vDesc].titulo,'');
              totalItens += parseFloat((pedidoDep[u][vItem].descricao[vDesc].valor+'').replace('R$ ','').replace('R$','').replace('.','').replace(',','.'));
            }
            if(item.mostrar_subtotal_itens){
              printer.leftRight('',"------");
              printer.bold(true);
              printer.leftRight('',"R$"+pedidoDep[u][vItem].total);
              printer.bold(false);
            }
            // if(pedidoDep[u][vItem].obs !== ""){
            //   printer.println('OBS: '+pedidoDep[u][vItem].obs);
            // }
            if(countDep < pedidoDep[ u ].length && item.impressao_espacamento_itens) printer.newLine();
          }
          printer.cut();
          //console.log(printer.getText());

          try {
            printer.execute();




        }catch(err){
           dialog.showMessageBox(null,{title:'Mensagem',message: 'Não foi possível imprimir.\n'+err});
        }





        }









       });





  });


  ipcMain.on('ping', (event, msg, options = {}) => {
  

      if(isClose)
        window.flashFrame(true);
       if(process.platform === 'darwin' && isClose){
        //notifier.notify(app.dock.getBadge());
        app.setBadgeCount(app.getBadgeCount() + 1);
          //app.dock.setBadge(parseInt(app.dock.getBadge() | 0) + 1);
      }

      if(process.platform === 'win32' ){

        tray.setImage(path.join(__dirname, 'icon.ico'));

      }
      
      
      
  });
}

app.commandLine.appendSwitch('ignore-certificate-errors');

const gotTheLock = app.requestSingleInstanceLock()

if (!gotTheLock) {
  app.quit()
} else {
  app.on('second-instance', (event, commandLine, workingDirectory) => {

    if (window) {
      window.restore();
      window.focus()
    }
  })
  app.whenReady().then(createWindow)
}

process.on('uncaughtException', (error, source) => {
  console.log('ProcessError',error);
});



