const ThermalPrinter = require("node-thermal-printer").printer;
const PrinterTypes = require("node-thermal-printer").types;

const fetch = require('node-fetch');
const pri = require('printer');



let printer = new ThermalPrinter({
  type: PrinterTypes.EPSON,                                  
  interface: 'printer:EPSON_TM_T20' ,             
  driver: pri
 
});


printer.isPrinterConnected(function(isOk){
  console.log(isOk);
});

var impresoras = [];


let url = "https://exemplo.byfood.com.br/admin/pedidos/printer/216780.json";
let settings = { method: "Get" };

fetch(url, settings)
    .then(res => res.json())
    .then((json) => {
        let item = json.pedido;


printer.alignCenter();
printer.println(item.owner);
printer.printQR(item.qrcode,{cellSize:3});
printer.setTextNormal();
printer.println();
printer.alignLeft();
printer.println('Loja: '+item.loja);
printer.println('Pedido: #'+item.pedido);
printer.println('Data: '+item.data);
printer.bold(true);
printer.println(item.pedido_loja);
printer.newLine();
printer.print('Dados do Cliente');
printer.bold(false);
printer.println('Nome: '+item.nome);
printer.println('Celular: '+item.celular);





if(item.retirar_no_local){
	printer.println('Retirada no local');
}else{
	printer.println('Endereço: '+item.logradouro+', '+item.logradouro_numero);
	printer.println('Bairro: '+item.bairro);
	printer.println('Compl: '+item.complemento);
	printer.println('Cidade: '+item.cidade);
}

printer.bold(true);
printer.println('Itens do pedido');
printer.bold(false);
printer.leftRight('Qtd  Item','Preço');
for(var vItem in item.itens){
	var spacingFirst = '    ';
	printer.leftRight(item.itens[vItem].quantidade+'    '+item.itens[vItem].titulo,'R$'+item.itens[vItem].valor);
	for(var vDesc in item.itens[vItem].descricao){
		printer.leftRight('     '+item.itens[vItem].descricao[vDesc].titulo,item.itens[vItem].descricao[vDesc].valor);
	}
}

printer.drawLine();
printer.leftRight('SubTotal','R$'+item.valor);
printer.leftRight('Taxa de Entrega','R$'+item.frete);
printer.bold(true);
printer.leftRight('Cobrar do Cliente','R$'+item.total);
printer.drawLine();
printer.bold(false);
printer.print('Formas de pagamento')
printer.bold(true);
printer.println(item.forma_pagamento);
printer.bold(false);

if(item.has_troco){
	printer.printl('Valor a receber em dinheiro: R$ '+item.receber_dinheiro);
}

if(item.viaCozinha){
	printer.cut();
	printer.drawLine();
	printer.alignCenter();
	printer.print('VIA DA COZINHA');
	if(item.retirar_no_local){
		printer.bold(true);
		printer.println('Retirar no Local');
		printer.bold(false);
	}
	printer.println('Loja: '+item.loja);
	printer.println('Pedido: #'+item.pedido);
	printer.println('Data: '+item.data);
	printer.println('Nome: '+item.nome);
	printer.println('Celular: '+item.celular);

	printer.println('Itens do pedido');
	printer.leftRight('Qtd  Item','');
	for(var vItem in item.itens){
		var spacingFirst = '    ';
		printer.leftRight(item.itens[vItem].quantidade+'    '+item.itens[vItem].titulo,'');
		for(var vDesc in item.itens[vItem].descricao){
			printer.leftRight('     '+item.itens[vItem].descricao[vDesc].titulo,'');
		}
	}




}

console.log(pri.getPrinters());
printer.execute();

//console.log(printer.getText());


 });








/*printer.cut();

try {
  let execute = printer.execute()
  console.error("Print done!");
} catch (error) {
  console.log("Print failed:", error);
}*/
